rm(list=ls(all=TRUE))
setwd("/home/andrea.tosin/Desktop/Folder")


# Caricamento Dati #


data = read.table("dati", header=TRUE)
#data = read.csv("", header=TRUE, sep=";")

data

data[1] -> anni
data[2] -> data1h
data[3] -> data3h
data[4] -> data6h
data[5] -> data12h
data[6] -> data24h

anni
data1h

anni1h <- anni[!is.na(data1h)]
anni3h <- anni[!is.na(data3h)]
anni6h <- anni[!is.na(data6h)]
anni12h <- anni[!is.na(data12h)]
anni24h <- anni[!is.na(data24h)]

anni1h

data1h <- data1h[!is.na(data1h)]
data3h <- data3h[!is.na(data3h)]
data6h <- data6h[!is.na(data6h)]
data12h <- data12h[!is.na(data12h)]
data24h <- data24h[!is.na(data24h)]

data1h

plot(anni1h, data1h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 1 ora", col="black", lwd="2", type="l")
plot(anni3h, data3h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 3 ore", col="black", lwd="2", type="l")
plot(anni6h, data6h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 6 ore", col="black", lwd="2", type="l")
plot(anni12h, data12h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 12 ore", col="black", lwd="2", type="l")
plot(anni24h, data24h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 24 ore", col="black", lwd="2", type="l")

#hist(data1h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime in 1 ora", col="black", lwd="2", type="l")

plot(anni6h, data6h, xlab="tempo t", ylab="altezza [mm]", main="Precipitazioni massime totali", col="blue", lwd="1", type="l", ylim=c(10,150))
lines(anni3h, data3h, col="red", lwd="1", type="l")
lines(anni24h, data24h, col="green", lwd="1", type="l")
lines(anni12h, data12h, col="purple", lwd="1", type="l")
lines(anni1h, data1h, col="orange", lwd="1", type="l")

#_______________________________________________________________________________________________________________________________________#


# Precipitazioni in 1 ora #


ecdf(data1h) -> ecdf1h
x <- seq(from=0, to=99, by=1)
ecdf1h(x)

plot(ecdf1h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="ECDF precipitazioni 1 ora")


# Metodo dei Momenti #


library("evd")

mean(data1h) -> mean1h
var(data1h) -> var1h
eulergamma = 0.5772156649
b1h_M <- sqrt(6*var1h)/pi
a1h_M <- mean1h-b1h_M*eulergamma

plot(ecdf1h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="Curve di Gumbel 1 ora")
lines(x, pgumbel(x, loc=a1h_M, scale=b1h_M), lwd=2, col="blue")


# Metodo di Massima Verosimiglianza #


library("MASS")

fitdistr(data1h, densfun=dgumbel, start=list(loc=a1h_M, scale=b1h_M)) -> ml1h
ml1h$estimate["loc"] -> a1h_V
ml1h$estimate["scale"] -> b1h_V

lines(x, pgumbel(x, loc=a1h_V, scale=b1h_V), lwd=2, col="green")


# Metodo dei Minimi Quadrati #


sort(data1h) -> sorted_data1h

ecdf1h(sorted_data1h)

Y <- -(log(-log(ecdf1h(sorted_data1h))))
Y <- Y[-50]
X <- sorted_data1h[-50]
lm(Y ~ X) -> l01h
b1h_Q <- 1/l01h$coefficients[2]
a1h_Q <- -l01h$coefficients[1]*b1h_Q

lines(x, pgumbel(x, loc=a1h_Q, scale=b1h_Q), lwd=2, col="red")


# Test di Pearson #


q <- c(0.2, 0.4, 0.6, 0.8)

qgumbel(q, loc=a1h_M, scale=b1h_M) -> qi1h_M               # metodo dei momenti
c(0, ecdf1h(qi1h_M))*length(data1h) -> no1_1h_M
c(ecdf1h(qi1h_M), 1)*length(data1h) -> no2_1h_M
no2_1h_M-no1_1h_M -> no_1h_M
0.2*length(data1h) -> deltapi1h_M
X1h_M <- sum((no_1h_M-deltapi1h_M)^2/deltapi1h_M)

qgumbel(q, loc=a1h_V, scale=b1h_V) -> qi1h_V               # metodo di massima verosimiglianza
c(0, ecdf1h(qi1h_V))*length(data1h) -> no1_1h_V
c(ecdf1h(qi1h_V), 1)*length(data1h) -> no2_1h_V
no2_1h_V-no1_1h_V -> no_1h_V
0.2*length(data1h) -> deltapi1h_V
X1h_V <- sum((no_1h_V-deltapi1h_V)^2/deltapi1h_V)

qgumbel(q, loc=a1h_Q, scale=b1h_Q) -> qi1h_Q               # metodo dei minimi quadrati
c(0, ecdf1h(qi1h_Q))*length(data1h) -> no1_1h_Q
c(ecdf1h(qi1h_Q), 1)*length(data1h) -> no2_1h_Q
no2_1h_Q-no1_1h_Q -> no_1h_Q
0.2*length(data1h) -> deltapi1h_Q
X1h_Q <- sum((no_1h_Q-deltapi1h_Q)^2/deltapi1h_Q)

X1h_M
X1h_V
X1h_Q

a1h = a1h_M 
b1h = b1h_M

a1h
b1h


#_______________________________________________________________________________________________________________________________________#


# Precipitazioni in 3 ore #


ecdf(data3h) -> ecdf3h
ecdf3h(x)

plot(ecdf3h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="ECDF precipitazioni 3 ore")


# Metodo dei Momenti #


mean(data3h) -> mean3h
var(data3h) -> var3h
eulergamma = 0.5772156649
b3h_M <- sqrt(6*var3h)/pi
a3h_M <- mean3h-b3h_M*eulergamma

plot(ecdf3h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="Curve di Gumbel 3 ore")
lines(x, pgumbel(x, loc=a3h_M, scale=b3h_M), lwd=2, col="blue")


# Metodo di Massima Verosimiglianza #


fitdistr(data3h, densfun=dgumbel, start=list(loc=a3h_M, scale=b3h_M)) -> ml3h
ml3h$estimate["loc"] -> a3h_V
ml3h$estimate["scale"] -> b3h_V

lines(x, pgumbel(x, loc=a3h_V, scale=b3h_V), lwd=2, col="green")


# Metodo dei Minimi Quadrati #


sort(data3h) -> sorted_data3h

ecdf3h(sorted_data3h)

Y <- -(log(-log(ecdf3h(sorted_data3h))))
Y <- Y[-50]
X <- sorted_data3h[-50]
lm(Y ~ X) -> l03h
b3h_Q <- 1/l03h$coefficients[2]
a3h_Q <- -l03h$coefficients[1]*b3h_Q

lines(x, pgumbel(x, loc=a3h_Q, scale=b3h_Q), lwd=2, col="red")


# Test di Pearson #


q <- c(0.2, 0.4, 0.6, 0.8)

qgumbel(q, loc=a3h_M, scale=b3h_M) -> qi3h_M               # metodo dei momenti
c(0, ecdf3h(qi3h_M))*length(data3h) -> no1_3h_M
c(ecdf3h(qi3h_M), 1)*length(data3h) -> no2_3h_M
no2_3h_M-no1_3h_M -> no_3h_M
0.2*length(data3h) -> deltapi3h_M
X3h_M <- sum((no_3h_M-deltapi3h_M)^2/deltapi3h_M)

qgumbel(q, loc=a3h_V, scale=b3h_V) -> qi3h_V               # metodo di massima verosimiglianza
c(0, ecdf3h(qi3h_V))*length(data3h) -> no1_3h_V
c(ecdf3h(qi3h_V), 1)*length(data3h) -> no2_3h_V
no2_3h_V-no1_3h_V -> no_3h_V
0.2*length(data3h) -> deltapi3h_V
X3h_V <- sum((no_3h_V-deltapi3h_V)^2/deltapi3h_V)

qgumbel(q, loc=a3h_Q, scale=b3h_Q) -> qi3h_Q               # metodo dei minimi quadrati
c(0, ecdf3h(qi3h_Q))*length(data3h) -> no1_3h_Q
c(ecdf3h(qi3h_Q), 1)*length(data3h) -> no2_3h_Q
no2_3h_Q-no1_3h_Q -> no_3h_Q
0.2*length(data3h) -> deltapi3h_Q
X3h_Q <- sum((no_3h_Q-deltapi3h_Q)^2/deltapi3h_Q)

X3h_M
X3h_V
X3h_Q

a3h = a3h_M
b3h = b3h_M

a3h
b3h


#_______________________________________________________________________________________________________________________________________#


# Precipitazioni in 6 ore #


ecdf(data6h) -> ecdf6h
ecdf6h(x)

plot(ecdf6h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="ECDF precipitazioni 6 ore")


# Metodo dei Momenti #


mean(data6h) -> mean6h
var(data6h) -> var6h
eulergamma = 0.5772156649
b6h_M <- sqrt(6*var6h)/pi
a6h_M <- mean6h-b6h_M*eulergamma

plot(ecdf6h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="Curve di Gumbel 6 ore")
lines(x, pgumbel(x, loc=a6h_M, scale=b6h_M), lwd=2, col="blue")


# Metodo di Massima Verosimiglianza #


fitdistr(data6h, densfun=dgumbel, start=list(loc=a6h_M, scale=b6h_M)) -> ml6h
ml6h$estimate["loc"] -> a6h_V
ml6h$estimate["scale"] -> b6h_V

lines(x, pgumbel(x, loc=a6h_V, scale=b6h_V), lwd=2, col="green")


# Metodo dei Minimi Quadrati #


sort(data6h) -> sorted_data6h

ecdf6h(sorted_data6h)

Y <- -(log(-log(ecdf6h(sorted_data6h))))
Y <- Y[-50]
X <- sorted_data6h[-50]
lm(Y ~ X) -> l06h
b6h_Q <- 1/l06h$coefficients[2]
a6h_Q <- -l06h$coefficients[1]*b6h_Q

lines(x, pgumbel(x, loc=a6h_Q, scale=b6h_Q), lwd=2, col="red")


# Test di Pearson #


q <- c(0.2, 0.4, 0.6, 0.8)

qgumbel(q, loc=a6h_M, scale=b6h_M) -> qi6h_M               # metodo dei momenti
c(0, ecdf6h(qi6h_M))*length(data6h) -> no1_6h_M
c(ecdf6h(qi6h_M), 1)*length(data6h) -> no2_6h_M
no2_6h_M-no1_6h_M -> no_6h_M
0.2*length(data6h) -> deltapi6h_M
X6h_M <- sum((no_6h_M-deltapi6h_M)^2/deltapi6h_M)

qgumbel(q, loc=a6h_V, scale=b6h_V) -> qi6h_V               # metodo di massima verosimiglianza
c(0, ecdf6h(qi6h_V))*length(data6h) -> no1_6h_V
c(ecdf6h(qi6h_V), 1)*length(data6h) -> no2_6h_V
no2_6h_V-no1_6h_V -> no_6h_V
0.2*length(data6h) -> deltapi6h_V
X6h_V <- sum((no_6h_V-deltapi6h_V)^2/deltapi6h_V)

qgumbel(q, loc=a6h_Q, scale=b6h_Q) -> qi6h_Q               # metodo dei minimi quadrati
c(0, ecdf6h(qi6h_Q))*length(data6h) -> no1_6h_Q
c(ecdf6h(qi6h_Q), 1)*length(data6h) -> no2_6h_Q
no2_6h_Q-no1_6h_Q -> no_6h_Q
0.2*length(data6h) -> deltapi6h_Q
X6h_Q <- sum((no_6h_Q-deltapi6h_Q)^2/deltapi6h_Q)

X6h_M
X6h_V
X6h_Q

a6h = a6h_M
b6h = b6h_M

a6h
b6h


#_______________________________________________________________________________________________________________________________________#


# Precipitazioni in 12 ore #


ecdf(data12h) -> ecdf12h
ecdf12h(x)

plot(ecdf12h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="ECDF precipitazioni 12 ore")


# Metodo dei Momenti #

q <- seq(from=0, to=200, by=1)
mean(data12h) -> mean12h
var(data12h) -> var12h
eulergamma = 0.5772156649
b12h_M <- sqrt(6*var12h)/pi
a12h_M <- mean12h-b12h_M*eulergamma

plot(ecdf12h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="Curve di Gumbel 12 ore")
lines(q, pgumbel(q, loc=a12h_M, scale=b12h_M), lwd=2, col="blue")


# Metodo di Massima Verosimiglianza #


fitdistr(data12h, densfun=dgumbel, start=list(loc=a12h_M, scale=b12h_M)) -> ml12h
ml12h$estimate["loc"] -> a12h_V
ml12h$estimate["scale"] -> b12h_V

lines(q, pgumbel(q, loc=a12h_V, scale=b12h_V), lwd=2, col="green")


# Metodo dei Minimi Quadrati #


sort(data12h) -> sorted_data12h

ecdf12h(sorted_data12h)

Y <- -(log(-log(ecdf12h(sorted_data12h))))
Y <- Y[-50]
X <- sorted_data12h[-50]
lm(Y ~ X) -> l012h
b12h_Q <- 1/l012h$coefficients[2]
a12h_Q <- -l012h$coefficients[1]*b12h_Q

lines(q, pgumbel(q, loc=a12h_Q, scale=b12h_Q), lwd=2, col="red")


# Test di Pearson #


q <- c(0.2, 0.4, 0.6, 0.8)

qgumbel(q, loc=a12h_M, scale=b12h_M) -> qi12h_M               # metodo dei momenti
c(0, ecdf12h(qi12h_M))*length(data12h) -> no1_12h_M
c(ecdf12h(qi12h_M), 1)*length(data12h) -> no2_12h_M
no2_12h_M-no1_12h_M -> no_12h_M
0.2*length(data12h) -> deltapi12h_M
X12h_M <- sum((no_12h_M-deltapi12h_M)^2/deltapi12h_M)

qgumbel(q, loc=a12h_V, scale=b12h_V) -> qi12h_V               # metodo di massima verosimiglianza
c(0, ecdf12h(qi12h_V))*length(data12h) -> no1_12h_V
c(ecdf12h(qi12h_V), 1)*length(data12h) -> no2_12h_V
no2_12h_V-no1_12h_V -> no_12h_V
0.2*length(data12h) -> deltapi12h_V
X12h_V <- sum((no_12h_V-deltapi12h_V)^2/deltapi12h_V)

qgumbel(q, loc=a12h_Q, scale=b12h_Q) -> qi12h_Q               # metodo dei minimi quadrati
c(0, ecdf12h(qi12h_Q))*length(data12h) -> no1_12h_Q
c(ecdf12h(qi12h_Q), 1)*length(data12h) -> no2_12h_Q
no2_12h_Q-no1_12h_Q -> no_12h_Q
0.2*length(data12h) -> deltapi12h_Q
X12h_Q <- sum((no_12h_Q-deltapi12h_Q)^2/deltapi12h_Q)

X12h_M
X12h_V
X12h_Q

a12h = a12h_M
b12h = b12h_M

a12h
b12h


#_______________________________________________________________________________________________________________________________________#


# Precipitazioni in 24 ore #


ecdf(data24h) -> ecdf24h
ecdf24h(x)

plot(ecdf24h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="ECDF precipitazioni 24 ore")


# Metodo dei Momenti #

w <- seq(from=0, to=250, by=1)
mean(data24h) -> mean24h
var(data24h) -> var24h
eulergamma = 0.5772156649
b24h_M <- sqrt(6*var24h)/pi
a24h_M <- mean24h-b24h_M*eulergamma

plot(ecdf24h, xlab="altezza [mm]", ylab="Frequenza [H<h]", main="Curve di Gumbel 24 ore")
lines(w, pgumbel(w, loc=a24h_M, scale=b24h_M), lwd=2, col="blue")


# Metodo di Massima Verosimiglianza #


fitdistr(data24h, densfun=dgumbel, start=list(loc=a24h_M, scale=b24h_M)) -> ml24h
ml24h$estimate["loc"] -> a24h_V
ml24h$estimate["scale"] -> b24h_V

lines(w, pgumbel(w, loc=a24h_V, scale=b24h_V), lwd=2, col="green")


# Metodo dei Minimi Quadrati #


sort(data24h) -> sorted_data24h

ecdf24h(sorted_data24h)

Y <- -(log(-log(ecdf24h(sorted_data24h))))
Y <- Y[-50]
X <- sorted_data24h[-50]
lm(Y ~ X) -> l024h
b24h_Q <- 1/l024h$coefficients[2]
a24h_Q <- -l024h$coefficients[1]*b24h_Q

lines(w, pgumbel(w, loc=a24h_Q, scale=b24h_Q), lwd=2, col="red")


# Test di Pearson #


q <- c(0.2, 0.4, 0.6, 0.8)

qgumbel(q, loc=a24h_M, scale=b24h_M) -> qi24h_M               # metodo dei momenti
c(0, ecdf24h(qi24h_M))*length(data24h) -> no1_24h_M
c(ecdf24h(qi24h_M), 1)*length(data24h) -> no2_24h_M
no2_24h_M-no1_24h_M -> no_24h_M
0.2*length(data24h) -> deltapi24h_M
X24h_M <- sum((no_24h_M-deltapi24h_M)^2/deltapi24h_M)

qgumbel(q, loc=a24h_V, scale=b24h_V) -> qi24h_V               # metodo di massima verosimiglianza
c(0, ecdf24h(qi24h_V))*length(data24h) -> no1_24h_V
c(ecdf24h(qi24h_V), 1)*length(data24h) -> no2_24h_V
no2_24h_V-no1_24h_V -> no_24h_V
0.2*length(data24h) -> deltapi24h_V
X24h_V <- sum((no_24h_V-deltapi24h_V)^2/deltapi24h_V)

qgumbel(q, loc=a24h_Q, scale=b24h_Q) -> qi24h_Q               # metodo dei minimi quadrati
c(0, ecdf24h(qi24h_Q))*length(data24h) -> no1_24h_Q
c(ecdf24h(qi24h_Q), 1)*length(data24h) -> no2_24h_Q
no2_24h_Q-no1_24h_Q -> no_24h_Q
0.2*length(data24h) -> deltapi24h_Q
X24h_Q <- sum((no_24h_Q-deltapi24h_Q)^2/deltapi24h_Q)

X24h_M
X24h_V
X24h_Q

a24h = a24h_M
b24h = b24h_M

a24h
b24h


#_______________________________________________________________________________________________________________________________________#


# Curve di Gumbel e Densità di Probabilità #


z <- seq(from=1, to=200, by=1)
plot(z, pgumbel(z, a1h, b1h), type="l", lwd=1, col="blue")            #curve di Gumbel
lines(z, pgumbel(z, a3h, b3h), type="l", lwd=1, col="orange")
lines(z, pgumbel(z, a6h, b6h), type="l", lwd=1, col="green")
lines(z, pgumbel(z, a12h, b12h), type="l", lwd=1, col="red")
lines(z, pgumbel(z, a24h, b24h), type="l", lwd=1, col="brown")

plot(z, dgumbel(z, a1h, b1h), type="l", lwd=1, col="blue")            # densità di probabilità delle curve di Gumbel
lines(z, dgumbel(z, a3h, b3h), type="l", lwd=1, col="orange")
lines(z, dgumbel(z, a6h, b6h), type="l", lwd=1, col="green")
lines(z, dgumbel(z, a12h, b12h), type="l", lwd=1, col="red")
lines(z, dgumbel(z, a24h, b24h), type="l", lwd=1, col="brown")


# Linee Segnalatrici di possibilità Pluviometrica #


durate <- c(1, 3, 6, 12, 24)
quantili <- c(1-1/10, 1-1/50, 1-1/100)

h1 <- c(qgumbel(quantili, a1h, b1h))
h3 <- c(qgumbel(quantili, a3h, b3h))
h6 <- c(qgumbel(quantili, a6h, b6h))
h12 <- c(qgumbel(quantili, a12h, b12h))
h24 <- c(qgumbel(quantili, a24h, b24h))


anni10 <- c(h1[1], h3[1], h6[1], h12[1], h24[1])           # curva di 10 anni
lm(log(anni10) ~ log(durate)) -> lr10
lr10$coefficients[1]
lr10$coefficients[2]
t10 <- seq(from=0.99, to=50, by=0.25)
plot(t10, exp(lr10$coefficients[1])*t10^lr10$coefficients[2], type="l", log="xy", col="lightblue", ylim=c(40, 300), xlab="tempo t", ylab="altezza [mm]", main="LSPP")
points(durate, anni10)


anni50 <- c(h1[2], h3[2], h6[2], h12[2], h24[2])           # curva di 50 anni
lm(log(anni50) ~ log(durate)) -> lr50
lr50$coefficients[1]
lr50$coefficients[2]
t50 <- seq(from=0.99, to=50, by=0.25)
lines(t50, exp(lr50$coefficients[1])*t50^lr50$coefficients[2], type="l", log="xy", col="lightgreen", ylim=c(40, 300), xlab="tempo t", ylab="altezza [mm]")
points(durate, anni50, pch=24)


anni100 <- c(h1[3], h3[3], h6[3], h12[3], h24[3])           # curva di 100 anni
lm(log(anni100) ~ log(durate)) -> lr100
lr50$coefficients[1]
lr50$coefficients[2]
t100 <- seq(from=0.99, to=50, by=0.25)
lines(t100, exp(lr100$coefficients[1])*t100^lr100$coefficients[2], type="l", log="xy", col="red", ylim=c(40, 300), xlab="tempo t", ylab="altezza [mm]")
points(durate, anni100, pch=22)
